Attribute VB_Name = "V3DNEU"
Option Explicit
Global aw As Double, ew As Double, Co As Double      'Winkel
Global X1(1000) As Integer, X2(1000) As Integer, Y1(1000) As Integer, Y2(1000) As Integer, Z1(1000) As Integer, Z2(1000) As Integer       'Koordinaten
Global Fa(1000) As Long                                                              'farbe
Global nx1(1000) As Integer, nx2(1000) As Integer, ny1(1000) As Integer, ny2(1000) As Integer, nz1(1000) As Integer, nz2(1000) As Integer 'zwischen Speicher
Global nfa(1000) As Long                                                             'zwischen Speicher
Global n As Integer               'letzte Linie
Global fan As Long                'aktuelle Farbe
Global xmin As Integer, ymin As Integer, xmax As Integer, ymax As Integer     'Scaleeinstellungen fr 3DBild
Global x0 As Integer, xdelta As Integer, y0 As Integer, ydelta As Integer     'Scaleeinstellungen des 3Dbildes in Verschiebung und Zoom umgewandelt
Global Filename As String                    'der im Moment Geladene File
Global letzter1 As String, letzter2 As String          'die beiden zuletzt geladenen Dateien
Global xmin1 As Integer, ymin1 As Integer, xmax1 As Integer, ymax1 As Integer, xmin2 As Integer, ymin2 As Integer, xmax2 As Integer, ymax2 As Integer, xmin3 As Integer, ymin3 As Integer, xmax3 As Integer, ymax3 As Integer    'die Scaleeinstellungen fr die 3 Ansichten in Verschiebung und Zoom
Global EndeMerker As Integer                 'ob die Datei gendert wurde
Global sal As Double, sbt As Double, cal As Double, cbt  As Double         'Werte um das 3DBild zu zeichnen
Global zoom2d As Single, zoom3D As Single              'Zommfaktoren fr die 3Ansichten und das 3DBild
Dim X As Integer, Y As Integer
Dim u As Integer, v As Integer
Global Merker As Integer
Global begr As Integer
Global Mpp As Integer, Mpk As Integer                    ' Merker fr Projektionsart
Global ynul As Integer, znul As Integer                  ' Verschiebung Augenpunkt
Global wdirectory As String             '
Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Dim v1 As Integer
Dim u1 As Integer
Global Const rot = &HFF&
Global Const Hrot = &H1080BF
Global Const hellgrau = &HC0C0C0
Global Const dunkelgrau = &H808080
Global Const wei = &HFFFFFF
Global Mrot As Integer

Global rckgng As Integer
Global Xsav As Integer, Ysav As Integer, Zsav As Integer, Isav As Integer
Global KForm As Integer
Global XZeiger As Integer
Global YZeiger As Integer
Global ZZeiger As Integer
Function nderungen_speichern()
Dim rck As Integer
If EndeMerker = 1 Then                        'Wenn etwas an der Datei gendert wurde
    rck = MsgBox("Wollen Sie die nderungen in der Datei '" & Filename & "' Speichern?", 35, "3D-Malprogrammm")
    If rck = 2 Then nderungen_speichern = 1 'ABBRECHEN
    If rck = 6 Then store                    'JA
                                              'bei NEIN passiert garnichts
End If

End Function

Sub Drucken()
Dim awr As Single, ewr As Single, u1 As Integer, v1 As Integer, u2 As Integer, v2 As Integer, i As Integer
Dim uz1 As Integer, uz2 As Integer, vz1 As Integer, vz2 As Integer

On Error GoTo 10
MDIForm1.stddialog.Flags = &H4& Or &H8& Or &H100000
MDIForm1.stddialog.Action = 5

awr = -aw * Atn(1#) / 45#
ewr = ew * Atn(1#) / 45#
sal = Sin(awr)
sbt = Sin(ewr)
cal = Cos(awr)
cbt = Cos(ewr)


If Mpp = 0 Then
For i = 1 To n
    Call trans(X1(i), Y1(i), Z1(i), u1, v1)
    Call trans(X2(i), Y2(i), Z2(i), u2, v2)
    Printer.Line (xmin + u1, ymin - v1)-(xmin + u2, ymin - v2), Fa(i)
Next i
Else
For i = 1 To n
    Call tranp(X1(i), Y1(i), Z1(i), u1, v1)
    Call tranp(X2(i), Y2(i), Z2(i), u2, v2)
    If (v1 > ynul + 500) And (v2 > ynul + 500) Then
    uz1 = -ynul * u1 / (v1 - ynul)
    uz2 = -ynul * u2 / (v2 - ynul)
    vz1 = -ynul * (Z1(i) - znul) / (v1 - ynul)
    vz2 = -ynul * (Z2(i) - znul) / (v2 - ynul)
    Printer.Line (xmin + uz1, ymin - vz1)-(xmin + uz2, ymin - vz2), Fa(i)
    End If
Next i
End If

Printer.EndDoc
10
Exit Sub

End Sub

Sub hoch(bild As Control)
Dim h As Long, br As Long

h = bild.Height
br = bild.Width
bild.Line (30, 30)-(br - 30, 30), wei
bild.Line (30, 30)-(30, h - 30), wei
bild.Line (br - 30, 30)-(br - 30, h - 30), dunkelgrau
bild.Line (br - 40, 30)-(br - 40, h - 30), dunkelgrau
bild.Line (30, h - 30)-(br - 30, h - 30), dunkelgrau
bild.Line (30, h - 40)-(br - 30, h - 40), dunkelgrau

End Sub

Sub linieweg()
Rem Linie lschen
Dim i As Integer, lp As Long, mp As Long, np As Long
Dim S1 As Single, S2 As Single, S3 As Single, DQ As Single, NQ As Single
Dim xan As Integer, RT1 As Integer, RT2 As Integer, vp As Integer
For i = 1 To n
    lp = X2(i) - X1(i)
    mp = Y2(i) - Y1(i)
    np = Z2(i) - Z1(i)
    NQ = lp * lp + mp * mp + np * np
    If NQ > 1 Then
        S1 = ((MDIForm1.xanf - X1(i)) * mp - (MDIForm1.yanf - Y1(i)) * lp) ^ 2
        S2 = ((MDIForm1.yanf - Y1(i)) * np - (MDIForm1.zanf - Z1(i)) * mp) ^ 2
        S3 = ((MDIForm1.zanf - Z1(i)) * lp - (MDIForm1.xanf - X1(i)) * np) ^ 2
        DQ = (S1 + S2 + S3) / NQ
        If lp <> 0 Then vp = lp: RT1 = X1(i): RT2 = X2(i): xan = MDIForm1.xanf
        If mp <> 0 Then vp = mp: RT1 = Y1(i): RT2 = Y2(i): xan = MDIForm1.yanf
        If np <> 0 Then vp = np: RT1 = Z1(i): RT2 = Z2(i): xan = MDIForm1.zanf
        MDIForm1.xend = RT1
        MDIForm1.yend = xan
        MDIForm1.zend = RT2
        If vp < 0 Then xan = -xan: RT1 = -RT1: RT2 = -RT2
        If DQ < 1 And (xan >= RT1) And (xan <= RT2) Then
            Xsav = X2(i)
            Ysav = Y2(i)
            Zsav = Z2(i)
            Isav = i
            X2(i) = X1(i)
            Y2(i) = Y1(i)
            Z2(i) = Z1(i)
        End If

    End If
Next i
v3dv
proje1
proje2
proje3
End Sub

Sub neben_einander()
Dim hhe As Integer, breite As Integer
MDIForm1.Arrange 1

hhe = MDIForm1.Height / 2 - 500
breite = MDIForm1.Width / 2 - 280
Form1.Top = 0
Form1.Left = breite + 420
Form1.Height = hhe - 100
Form1.Width = breite - 100
Form2.Top = 0
Form2.Left = 420
Form2.Height = hhe - 100
Form2.Width = breite
Form3.Top = hhe - 100
Form3.Left = 420
Form3.Height = hhe - 100
Form3.Width = breite
Form4.Top = hhe - 100
Form4.Left = breite + 420
Form4.Height = hhe - 100
Form4.Width = breite - 100
Form5.Top = 0
Form5.Height = MDIForm1.Height - 1000
Form5.Width = 420
Form5.Left = 0
Form5.Linie1.Y2 = MDIForm1.Height - 1000
Form5.Linie3.Y1 = MDIForm1.Height - 1000
Form5.Linie4.Y1 = MDIForm1.Height - 1000
Form5.Linie4.Y2 = MDIForm1.Height - 1000

End Sub

Sub neu()
Dim i As Integer
If nderungen_speichern() = 1 Then Exit Sub
Form1.Bild1.Cls
Form2.Bild1.Cls
Form3.Bild1.Cls
Form4.Cls
For i = 1 To n
    X1(i) = 0
    X2(i) = 0
    Y1(i) = 0
    Y2(i) = 0
    Z1(i) = 0
    Z2(i) = 0
    Fa(i) = 0
Next i
fan = 0
EndeMerker = 0
rckgng = 0
Merker = 0
Filename = "unbennant"
zoom2d = 5
zoom3D = 5
MDIForm1.Caption = "3D-Malprogramm [unbenannt]"

End Sub

Sub ffnen()
Dim xe1 As Variant, ye1 As Variant, ze1 As Variant, xe2 As Variant, ye2 As Variant, ze2 As Variant
Dim i As Integer
On Error GoTo ErrHandler
MDIForm1.stddialog.Filter = "Geometriedaten (*.dat)|*.dat"
MDIForm1.stddialog.Action = 1                     'Standartdialogbox anzeigen
If MDIForm1.stddialog.Filename <> "" Then         'Wenn nicht ABBRECHEN geclickt wurde
    If nderungen_speichern() = 1 Then Exit Sub
    'Datei wird geladen
    Open (MDIForm1.stddialog.Filename) For Input As 2
    Input #2, n
    For i = 1 To n
    Input #2, xe1, ye1, ze1, xe2, ye2, ze2, Fa(i)
    X1(i) = xe1: X2(i) = xe2
    Y1(i) = ye1: Y2(i) = ye2
    Z1(i) = ze1: Z2(i) = ze2
    
    Next i
    Close 2
    EndeMerker = 0
    rckgng = 0

    'Form.caption und die dynamischen Felder werden initialisiert
    Filename = MDIForm1.stddialog.Filename
    MDIForm1.Caption = "3D-Malprogramm[" & Filename & "]"

    If letzter1 <> Filename Then
        letzter2 = letzter1
        letzter1 = Filename
        MDIForm1.dynamisch(1).Visible = True
        MDIForm1.dynamisch(1).Caption = letzter1
        If letzter2 <> "" Then
            MDIForm1.dynamisch(2).Visible = True
            MDIForm1.dynamisch(2).Caption = letzter2
        End If
    End If

    'Anzeigen werden aktualisiert
    Call proje1
    Call proje2
    Call proje3
    Call v3dv
End If
Exit Sub

ErrHandler:
    If Err = 32755 Then Exit Sub
    MsgBox ("Lesefehler")
    Close 2
    Exit Sub

End Sub

Sub proje1()
Dim i As Integer
Form1.Bild1.Cls
For i = 1 To n
Form1.Bild1.Line (xmin1 - zoom2d * Y1(i), ymin1 - zoom2d * Z1(i))-(xmin1 - zoom2d * Y2(i), ymin1 - zoom2d * Z2(i)), Fa(i)
Next i
If Merker = 0 Then
    Form1.Linie1.X1 = xmin1 - Val(MDIForm1.yanf) * zoom2d
    Form1.Linie1.X2 = xmin1 - Val(MDIForm1.yanf) * zoom2d
    Form1.Linie2.Y1 = ymin1 - Val(MDIForm1.zanf) * zoom2d
    Form1.Linie2.Y2 = ymin1 - Val(MDIForm1.zanf) * zoom2d
    Else
    Form1.Linie1.X1 = xmin1 - Val(MDIForm1.yend) * zoom2d
    Form1.Linie1.X2 = xmin1 - Val(MDIForm1.yend) * zoom2d
    Form1.Linie2.Y1 = ymin1 - Val(MDIForm1.zend) * zoom2d
    Form1.Linie2.Y2 = ymin1 - Val(MDIForm1.zend) * zoom2d
End If
End Sub

Sub proje2()
Dim i As Integer
Form2.Bild1.Cls
For i = 1 To n
Form2.Bild1.Line (xmin2 + zoom2d * X1(i), ymin2 - zoom2d * Z1(i))-(xmin2 + zoom2d * X2(i), ymin2 - zoom2d * Z2(i)), Fa(i)
Next i
If Merker = 0 Then
    Form2.Linie1.X1 = Val(MDIForm1.xanf) * zoom2d + xmin2
    Form2.Linie1.X2 = Val(MDIForm1.xanf) * zoom2d + xmin2
    Form2.Linie2.Y1 = ymin2 - Val(MDIForm1.zanf) * zoom2d
    Form2.Linie2.Y2 = ymin2 - Val(MDIForm1.zanf) * zoom2d
Else
    Form2.Linie1.X1 = Val(MDIForm1.xend) * zoom2d + xmin2
    Form2.Linie1.X2 = Val(MDIForm1.xend) * zoom2d + xmin2
    Form2.Linie2.Y1 = ymin2 - Val(MDIForm1.zend) * zoom2d
    Form2.Linie2.Y2 = ymin2 - Val(MDIForm1.zend) * zoom2d
End If

End Sub

Sub proje3()
Dim i As Integer
Form3.Bild1.Cls
For i = 1 To n
Form3.Bild1.Line (xmin3 + zoom2d * X1(i), ymin3 - zoom2d * Y1(i))-(xmin3 + zoom2d * X2(i), ymin3 - zoom2d * Y2(i)), Fa(i)
Next i
If Merker = 0 Then
    Form3.Linie1.X1 = Val(MDIForm1.xanf) * zoom2d + xmin3
    Form3.Linie1.X2 = Val(MDIForm1.xanf) * zoom2d + xmin3
    Form3.Linie2.Y1 = ymin3 - Val(MDIForm1.yanf) * zoom2d
    Form3.Linie2.Y2 = ymin3 - Val(MDIForm1.yanf) * zoom2d
Else
    Form3.Linie1.X1 = Val(MDIForm1.xend) * zoom2d + xmin3
    Form3.Linie1.X2 = Val(MDIForm1.xend) * zoom2d + xmin3
    Form3.Linie2.Y1 = ymin3 - Val(MDIForm1.yend) * zoom2d
    Form3.Linie2.Y2 = ymin3 - Val(MDIForm1.yend) * zoom2d
End If

End Sub

'--------------------------------------------------------------------------------------------------------------------
'Zeichnen der drei projezierten Ansichten
Sub projektionen()
Dim i As Integer
'screen.MousePointer = 11
Form1.Bild1.Cls
For i = 1 To n
Form1.Bild1.Line (xmin1 + X1(i) * zoom2d, ymin1 - zoom2d * Z1(i))-(xmin1 + zoom2d * X2(i), ymin1 - zoom2d * Z2(i)), Fa(i)
Next i

Form2.Bild1.Cls
For i = 1 To n
Form2.Bild1.Line (xmin2 + zoom2d * Y1(i), ymin2 - zoom2d * Z1(i))-(xmin2 + zoom2d * Y2(i), ymin2 - zoom2d * Z2(i)), Fa(i)
Next i

Form3.Bild1.Cls
For i = 1 To n
Form3.Bild1.Line (xmin3 + zoom2d * X1(i), ymin3 - zoom2d * Y1(i))-(xmin3 + zoom2d * X2(i), ymin3 - zoom2d * Y2(i)), Fa(i)
Next i
'screen.MousePointer = 0
End Sub

Sub Reorg()
Rem Reorganisieren des Datenfeldes, Entfernen der Punkte

Dim ifr As Integer, i As Integer
ifr = 1
For i = 1 To n
If X1(i) <> X2(i) Or Y1(i) <> Y2(i) Or Z1(i) <> Z2(i) Then
    X1(ifr) = X1(i)
    Y1(ifr) = Y1(i)
    Z1(ifr) = Z1(i)
    X2(ifr) = X2(i)
    Y2(ifr) = Y2(i)
    Z2(ifr) = Z2(i)
    Fa(ifr) = Fa(i)
    ifr = ifr + 1
End If
Next i
n = ifr - 1
End Sub

Sub runter(bild As Control)
Dim h As Long, br As Long
h = bild.Height
br = bild.Width
bild.Line (br - 30, 30)-(br - 30, h - 30), hellgrau
bild.Line (br - 40, 30)-(br - 40, h - 30), hellgrau
bild.Line (30, h - 30)-(br - 30, h - 30), hellgrau
bild.Line (30, h - 40)-(br - 30, h - 40), hellgrau
bild.Line (30, 30)-(br, 30), dunkelgrau
bild.Line (30, 30)-(30, h), dunkelgrau

End Sub

Sub store()
Dim i As Integer
On Error GoTo errhandler1
If Filename = "unbennant" Then
    MDIForm1.stddialog.Action = 2
    Filename = MDIForm1.stddialog.Filename
    If Filename = "" Then Exit Sub
End If
Open Filename For Output As 1     'Datei ffnen
Write #1, n
For i = 1 To n
Write #1, X1(i), Y1(i), Z1(i), X2(i), Y2(i), Z2(i), Fa(i)
Next i
Close 1
MDIForm1.Caption = "3dMalprogramm[" & Filename & "]"
If letzter1 <> Filename Then
letzter2 = letzter1
letzter1 = Filename
MDIForm1.dynamisch(1).Visible = True
MDIForm1.dynamisch(1).Caption = letzter1
    If letzter2 <> "" Then
        MDIForm1.dynamisch(2).Visible = True
        MDIForm1.dynamisch(2).Caption = letzter2
    End If
End If

EndeMerker = 0

Exit Sub
errhandler1:
    If Err = 32755 Then Exit Sub
    MsgBox ("Beim Speichern ist ein Fehler aufgetreten")
    Close 1
Exit Sub
End Sub

Sub tasten_behandlung(keycode As Integer, Shift As Integer)
Dim awr As Single, ewr As Single, u1 As Integer, u2 As Integer, v1 As Integer, v2 As Integer, uz1 As Integer, vz1 As Integer, vz2 As Integer, uz2 As Integer
Dim i As Integer, delta As Integer, fu1 As Single, fu2 As Single
Dim tzl As String
Dim Nkx As Single, Nky As Single, Rkr As Integer
If Shift = 0 Then delta = 50        'nichts: normal
If Shift = 1 Then delta = 5         'shift: kleiner
If Shift = 2 Then delta = 500        'Strg: grer
If Shift = 4 Then delta = 1          'alt: sehr klein

Select Case keycode
    Case 13
        Rem Enter
        If Merker = 1 Then
        If Mpk = 0 Then
            Form1.Linie1.X1 = xmin1 - MDIForm1.yend * zoom2d
            Form1.Linie1.X2 = xmin1 - MDIForm1.yend * zoom2d
            Form3.Linie1.X1 = xmin3 + MDIForm1.xend * zoom2d
            Form3.Linie1.X2 = xmin3 + MDIForm1.xend * zoom2d

            Form2.Linie1.X1 = xmin2 + MDIForm1.xend * zoom2d
            Form2.Linie1.X2 = xmin2 + MDIForm1.xend * zoom2d
            Form3.Linie2.Y1 = ymin3 - MDIForm1.yend * zoom2d
            Form3.Linie2.Y2 = ymin3 - MDIForm1.yend * zoom2d

            Form1.Linie2.Y1 = ymin1 - MDIForm1.zend * zoom2d
            Form1.Linie2.Y2 = ymin1 - MDIForm1.zend * zoom2d
            Form2.Linie2.Y1 = ymin2 - MDIForm1.zend * zoom2d
            Form2.Linie2.Y2 = ymin2 - MDIForm1.zend * zoom2d

            If Mrot = 1 Then MDIForm1.xanf.BackColor = rot
            MDIForm1.xend.BackColor = hellgrau
            MDIForm1.yend.BackColor = hellgrau
            MDIForm1.zend.BackColor = hellgrau

            EndeMerker = 1
            rckgng = 1
            n = n + 1
            X1(n) = Val(MDIForm1.xanf)
            X2(n) = Val(MDIForm1.xend)
            Y1(n) = Val(MDIForm1.yanf)
            Y2(n) = Val(MDIForm1.yend)
            Z1(n) = Val(MDIForm1.zanf)
            Z2(n) = Val(MDIForm1.zend)
            Fa(n) = fan
            Call proje1
            Call proje2
            Call proje3
            
            awr = -aw * Atn(1#) / 45#
            ewr = ew * Atn(1#) / 45#
            sal = Sin(awr)
            sbt = Sin(ewr)
            cal = Cos(awr)
            cbt = Cos(ewr)
            If Mpp = 0 Then
                Call trans(X1(n), Y1(n), Z1(n), u1, v1)
                Call trans(X2(n), Y2(n), Z2(n), u2, v2)
                Form4.Line (xmin + u1 * zoom3D, ymin - v1 * zoom3D)-(xmin + u2 * zoom3D, ymin - v2 * zoom3D), Fa(n)
            Else
                Call tranp(X1(n), Y1(n), Z1(n), u1, v1)
                Call tranp(X2(n), Y2(n), Z2(n), u2, v2)
                If (v1 > ynul + 500) And (v2 > ynul + 500) Then
                fu1 = -ynul / (v1 - ynul)
                fu2 = -ynul / (v2 - ynul)
                uz1 = u1 * fu1 * zoom3D
                uz2 = u2 * fu2 * zoom3D
                vz1 = (Z1(n) - znul) * fu1 * zoom3D
                vz2 = (Z2(n) - znul) * fu2 * zoom3D
                Form4.Line (xmin + uz1, ymin - vz1)-(xmin + uz2, ymin - vz2), Fa(n)
                End If
            End If
            MDIForm1.xanf = X2(n)
            MDIForm1.yanf = Y2(n)
            MDIForm1.zanf = Z2(n)
            MDIForm1.xend = ""
            MDIForm1.yend = ""
            MDIForm1.zend = ""
        Else 'Kreiseingabe
            '
            '
            '
            Form1.Linie2.Y1 = ymin1 + MDIForm1.zanf * zoom2d
            Form1.Linie2.Y2 = ymin1 + MDIForm1.zanf * zoom2d
            Form2.Linie2.Y1 = ymin2 + MDIForm1.zanf * zoom2d
            Form2.Linie2.Y2 = ymin2 + MDIForm1.zanf * zoom2d
            Mpk = 0
            'Form5.Bild13.Visible = True
            'Form5.Bild14.Visible = False
        End If
        Else 'Anfangswerte
            If Mrot = 1 Then MDIForm1.xend.BackColor = rot
            MDIForm1.xanf.BackColor = hellgrau
            MDIForm1.yanf.BackColor = hellgrau
            MDIForm1.zanf.BackColor = hellgrau
            If Mpk = 0 Then
                MDIForm1.xend = MDIForm1.xanf
                MDIForm1.yend = MDIForm1.yanf
                MDIForm1.zend = MDIForm1.zanf
            Else
                MDIForm1.xend = 0
                MDIForm1.yend = 0
                MDIForm1.zend = 0
            End If
            Form1.Linie1.X1 = xmin1 - MDIForm1.yanf * zoom2d
            Form1.Linie1.X2 = xmin1 - MDIForm1.yanf * zoom2d
            Form3.Linie1.X1 = xmin3 + MDIForm1.xanf * zoom2d
            Form3.Linie1.X2 = xmin3 + MDIForm1.xanf * zoom2d

            Form2.Linie1.X1 = xmin2 + MDIForm1.xanf * zoom2d
            Form2.Linie1.X2 = xmin2 + MDIForm1.xanf * zoom2d
            Form3.Linie2.Y1 = ymin3 - MDIForm1.yanf * zoom2d
            Form3.Linie2.Y2 = ymin3 - MDIForm1.yanf * zoom2d

            Form1.Linie2.Y1 = ymin1 - MDIForm1.zanf * zoom2d
            Form1.Linie2.Y2 = ymin1 - MDIForm1.zanf * zoom2d
            Form2.Linie2.Y1 = ymin2 - MDIForm1.zanf * zoom2d
            Form2.Linie2.Y2 = ymin2 - MDIForm1.zanf * zoom2d

        End If
        Merker = 1 - Merker
        
    Case 39
        Rem  rechts
        If Mpk = 0 Or Merker = 0 Then
            Form2.Linie1.X1 = Form2.Linie1.X1 + delta
            Form2.Linie1.X2 = Form2.Linie1.X2 + delta
            Form3.Linie1.X1 = Form3.Linie1.X1 + delta
            Form3.Linie1.X2 = Form3.Linie1.X2 + delta
            XZeiger = XZeiger + delta / zoom2d
            v3dv
            If Merker = 0 Then
                MDIForm1.xanf = (Form2.Linie1.X1 - xmin2) / zoom2d
            Else
                MDIForm1.xend = (Form2.Linie1.X1 - xmin2) / zoom2d
            End If
        Else
            Rem Neigung des Kreises (x)
            MDIForm1.xend = MDIForm1.xend + delta / 10
            If MDIForm1.xend > 90 Then MDIForm1.xend = 90
            If MDIForm1.xend < 90 Then
            Form2.Linie2.Visible = True
            Form2.Linie2.Y1 = ymin1 + MDIForm1.zanf + (MDIForm1.xanf + xmin1) * Tan(MDIForm1.xend * Atn(1#) / 45)
            Form2.Linie2.Y2 = Form2.Linie2.Y1 - Form2.Linie2.X2 * Tan(MDIForm1.xend * Atn(1#) / 45)
            Else
            Form2.Linie2.Visible = False
            End If
        End If
    Case 37
        Rem links
        If Mpk = 0 Or Merker = 0 Then
            Form2.Linie1.X1 = Form2.Linie1.X1 - delta
            Form2.Linie1.X2 = Form2.Linie1.X2 - delta
            Form3.Linie1.X1 = Form3.Linie1.X1 - delta
            Form3.Linie1.X2 = Form3.Linie1.X2 - delta
            XZeiger = XZeiger - delta / zoom2d
            v3dv
            If Merker = 0 Then
                MDIForm1.xanf = (Form2.Linie1.X1 - xmin2) / zoom2d
            Else
                MDIForm1.xend = (Form2.Linie1.X1 - xmin2) / zoom2d
            End If
        Else
        Rem Neigung des Kreises (-x)
            MDIForm1.xend = MDIForm1.xend - delta / 10
            If MDIForm1.xend < -90 Then MDIForm1.xend = -90
            If MDIForm1.xend > -90 Then
            Form1.Linie2.Visible = True
            Form1.Linie2.Y1 = ymin1 + MDIForm1.zanf + (MDIForm1.xanf + xmin1) * Tan(MDIForm1.xend * Atn(1#) / 45)
            Form1.Linie2.Y2 = Form1.Linie2.Y1 - Form1.Linie2.X2 * Tan(MDIForm1.xend * Atn(1#) / 45)
            Else
            Form1.Linie2.Visible = False
            End If
    End If
    Case 38
        Rem hinten
        If Mpk = 0 Or Merker = 0 Then
            Form1.Linie1.X1 = Form1.Linie1.X1 - delta
            Form1.Linie1.X2 = Form1.Linie1.X2 - delta
            Form3.Linie2.Y1 = Form3.Linie2.Y1 - delta
            Form3.Linie2.Y2 = Form3.Linie2.Y2 - delta
            YZeiger = YZeiger + delta / zoom2d
            v3dv
            If Merker = 0 Then
                MDIForm1.yanf = (ymin3 - Form3.Linie2.Y1) / zoom2d
            Else
                MDIForm1.yend = (ymin3 - Form3.Linie2.Y1) / zoom2d
            End If
        Else
        Rem Neigung dse Kreises (y)
            MDIForm1.yend = MDIForm1.yend + delta / 10
            If MDIForm1.yend > 90 Then MDIForm1.yend = 90
            If MDIForm1.yend < 90 Then
            Form2.Linie2.Visible = True
            Form2.Linie2.Y1 = ymin2 + MDIForm1.zanf + (MDIForm1.yanf + xmin2) * Tan(MDIForm1.yend * Atn(1#) / 45)
            Form2.Linie2.Y2 = Form2.Linie2.Y1 - Form2.Linie2.X2 * Tan(MDIForm1.yend * Atn(1#) / 45)
            Else
            Form2.Linie2.Visible = False
            End If
            
        End If
    Case 40
        Rem vorne
        If Mpk = 0 Or Merker = 0 Then
            Form1.Linie1.X1 = Form1.Linie1.X1 + delta
            Form1.Linie1.X2 = Form1.Linie1.X2 + delta
            Form3.Linie2.Y1 = Form3.Linie2.Y1 + delta
            Form3.Linie2.Y2 = Form3.Linie2.Y2 + delta
            YZeiger = YZeiger - delta / zoom2d
            v3dv
            If Merker = 0 Then
                MDIForm1.yanf = (ymin3 - Form3.Linie2.Y1) / zoom2d
            Else
                MDIForm1.yend = (ymin3 - Form3.Linie2.Y1) / zoom2d
            End If
        Else
        Rem Neigung des Kreise (-y)
            MDIForm1.yend = MDIForm1.yend - delta / 10
            If MDIForm1.yend < -90 Then MDIForm1.yend = -90
            If MDIForm1.yend > -90 Then
            Form2.Linie2.Visible = True
            Form2.Linie2.Y1 = ymin2 + MDIForm1.zanf + (MDIForm1.yanf + xmin2) * Tan(MDIForm1.yend * Atn(1#) / 45)
            Form2.Linie2.Y2 = Form2.Linie2.Y1 - Form2.Linie2.X2 * Tan(MDIForm1.yend * Atn(1#) / 45)
            Else
            Form2.Linie2.Visible = False
            End If

        End If
    Case 34
        Rem runter
        If Mpk = 0 Or Merker = 0 Then
            Form1.Linie2.Y1 = Form1.Linie2.Y1 + delta
            Form1.Linie2.Y2 = Form1.Linie2.Y2 + delta
            Form2.Linie2.Y1 = Form2.Linie2.Y1 + delta
            Form2.Linie2.Y2 = Form2.Linie2.Y2 + delta
            ZZeiger = ZZeiger - delta / zoom2d
            v3dv
            If Merker = 0 Then
                MDIForm1.zanf = (ymin2 - Form2.Linie2.Y1) / zoom2d
            Else
                MDIForm1.zend = (ymin2 - Form2.Linie2.Y1) / zoom2d
            End If
        Else
            Rem Kreisradius verkeinern
        End If
    Case 33
        Rem hoch
        If Mpk = 0 Or Merker = 0 Then
            Form1.Linie2.Y1 = Form1.Linie2.Y1 - delta
            Form1.Linie2.Y2 = Form1.Linie2.Y2 - delta
            Form2.Linie2.Y1 = Form2.Linie2.Y1 - delta
            Form2.Linie2.Y2 = Form2.Linie2.Y2 - delta
            ZZeiger = ZZeiger + delta / zoom2d
            v3dv
            If Merker = 0 Then
                MDIForm1.zanf = (ymin2 - Form2.Linie2.Y1) / zoom2d
            Else
                MDIForm1.zend = (ymin2 - Form2.Linie2.Y1) / zoom2d
            End If
        Else
            Rem Radius des Kreises vergrern
        End If
    Case 97                         '1: Entfernung weiter
        If Mpp = 1 Then ynul = ynul - 200
        MDIForm1.Text4 = Val(ynul)
        v3dv
    Case 98                         '2: runter kippen
        If Mpp = 0 Then ew = ew - 5
        MDIForm1.Text2 = Val(ew)
        v3dv
    Case 99                         '3: Augenhhe runter
        If Mpp = 1 Then znul = znul - 100
        MDIForm1.Text3 = Val(znul)
        v3dv
    Case 100                         '4: links drehen
        aw = aw + 5
        v3dv
        MDIForm1.Text1 = Val(aw)
    Case 102                         '6: rechts drehen
        aw = aw - 5
        MDIForm1.Text1 = Val(aw)
        v3dv
    Case 103                        '7: Entfernung nher
        If Mpp = 1 Then ynul = ynul + 200
        MDIForm1.Text4 = Val(ynul)
        v3dv
    Case 104                         '8: hoch kippen
        If Mpp = 0 Then ew = ew + 5
        MDIForm1.Text2 = Val(ew)
        v3dv
    Case 105                        '9: Augenpunkt hher
        If Mpp = 1 Then znul = znul + 100
        MDIForm1.Text3 = Val(znul)
        v3dv
    Case 8, 46
        If MDIForm1.xanf.BackColor = rot And Len(MDIForm1.xanf) > 0 Then
              MDIForm1.xanf = Left(MDIForm1.xanf, Len(MDIForm1.xanf) - 1)
        ElseIf MDIForm1.yanf.BackColor = rot And Len(MDIForm1.yanf) > 0 Then: MDIForm1.yanf = Left(MDIForm1.yanf, Len(MDIForm1.yanf) - 1)
        ElseIf MDIForm1.zanf.BackColor = rot And Len(MDIForm1.zanf) > 0 Then: MDIForm1.zanf = Left(MDIForm1.zanf, Len(MDIForm1.zanf) - 1)
        ElseIf MDIForm1.xend.BackColor = rot And Len(MDIForm1.xend) > 0 Then: MDIForm1.xend = Left(MDIForm1.xend, Len(MDIForm1.xend) - 1)
        ElseIf MDIForm1.yend.BackColor = rot And Len(MDIForm1.yend) > 0 Then: MDIForm1.yend = Left(MDIForm1.yend, Len(MDIForm1.yend) - 1)
        ElseIf MDIForm1.zend.BackColor = rot And Len(MDIForm1.zend) > 0 Then: MDIForm1.zend = Left(MDIForm1.zend, Len(MDIForm1.zend) - 1)
        Else: Beep
        End If
    Case 48 To 59                                   'Ziffer
        If MDIForm1.xanf.BackColor = rot Then
              MDIForm1.xanf = Val(MDIForm1.xanf) * 10 + keycode - 48
        ElseIf MDIForm1.yanf.BackColor = rot Then: MDIForm1.yanf = Val(MDIForm1.yanf) * 10 + keycode - 48
        ElseIf MDIForm1.zanf.BackColor = rot Then: MDIForm1.zanf = Val(MDIForm1.zanf) * 10 + keycode - 48
        ElseIf MDIForm1.xend.BackColor = rot Then: MDIForm1.xend = Val(MDIForm1.xend) * 10 + keycode - 48
        ElseIf MDIForm1.yend.BackColor = rot Then: MDIForm1.yend = Val(MDIForm1.yend) * 10 + keycode - 48
        ElseIf MDIForm1.zend.BackColor = rot Then: MDIForm1.zend = Val(MDIForm1.zend) * 10 + keycode - 48
        Else: Beep
        End If
    Case 9                                          'tab
        If MDIForm1.xanf.BackColor = rot Then
            MDIForm1.yanf.BackColor = rot: MDIForm1.xanf.BackColor = hellgrau
        ElseIf MDIForm1.yanf.BackColor = rot Then: MDIForm1.zanf.BackColor = rot: MDIForm1.yanf.BackColor = hellgrau
        ElseIf MDIForm1.zanf.BackColor = rot Then: MDIForm1.xanf.BackColor = rot: MDIForm1.zanf.BackColor = hellgrau
        ElseIf MDIForm1.xend.BackColor = rot Then: MDIForm1.yend.BackColor = rot: MDIForm1.xend.BackColor = hellgrau
        ElseIf MDIForm1.yend.BackColor = rot Then: MDIForm1.zend.BackColor = rot: MDIForm1.yend.BackColor = hellgrau
        ElseIf MDIForm1.zend.BackColor = rot Then: MDIForm1.xend.BackColor = rot: MDIForm1.zend.BackColor = hellgrau
        Else
            Mrot = 1
            runter Form5.Bild9
            If Merker = 0 Then
            MDIForm1.xanf.BackColor = rot
            Else: MDIForm1.xend.BackColor = rot
            End If
        End If
    Case 27                      'Esc
        Mrot = 0
        hoch Form5.Bild9
        MDIForm1.xanf.BackColor = hellgrau
        MDIForm1.yanf.BackColor = hellgrau
        MDIForm1.zanf.BackColor = hellgrau
        MDIForm1.xend.BackColor = hellgrau
        MDIForm1.yend.BackColor = hellgrau
        MDIForm1.zend.BackColor = hellgrau
    Case 110                                 'NUM Entf
        If Merker = 0 Then rckgng = 2: Call linieweg
        If Merker = 1 Then
            Merker = 0
            If Mrot = 1 Then MDIForm1.xanf.BackColor = rot
            MDIForm1.xend.BackColor = hellgrau
            MDIForm1.yend.BackColor = hellgrau
            MDIForm1.zend.BackColor = hellgrau
            MDIForm1.xanf = MDIForm1.xend
            MDIForm1.yanf = MDIForm1.yend
            MDIForm1.zanf = MDIForm1.zend
            MDIForm1.xend = ""
            MDIForm1.yend = ""
            MDIForm1.zend = ""
        End If

End Select

End Sub

Sub tranp(X As Integer, Y As Integer, z As Integer, u As Integer, v As Integer)
u = X * cal - Y * sal
v = X * sal + Y * cal

End Sub

'----------------------------------------------------------------------------------
'Transformation 3D-2D
Sub trans(X As Integer, Y As Integer, z As Integer, u As Integer, v As Integer)
u = X * cal - Y * sal
v = X * sal * sbt + Y * cal * sbt + z * cbt
End Sub

'----------------------------------------------------------------------------------
'3D-Bild zeichnen
Sub v3dv()
Dim uz1 As Integer, uz2 As Integer, vz1 As Integer, vz2 As Integer, awr As Single, ewr As Single, u1 As Integer, v1 As Integer, u2 As Integer, v2 As Integer, vvy As Single
Dim LZeiger As Integer
Dim i As Integer
'screen.MousePointer = 11
LZeiger = 100
awr = -aw * Atn(1#) / 45#
ewr = ew * Atn(1#) / 45#
sal = Sin(awr)
sbt = Sin(ewr)
cal = Cos(awr)
cbt = Cos(ewr)

Form4.Cls

If Mpp = 0 Then
For i = 1 To n
    u1 = X1(i) * cal - Y1(i) * sal
    v1 = X1(i) * sal * sbt + Y1(i) * cal * sbt + Z1(i) * cbt

    u2 = X2(i) * cal - Y2(i) * sal
    v2 = X2(i) * sal * sbt + Y2(i) * cal * sbt + Z2(i) * cbt
    
Form4.Line (xmin + u1 * zoom3D, ymin - v1 * zoom3D)-(xmin + u2 * zoom3D, ymin - v2 * zoom3D), Fa(i)
Next i
Rem Zeiger X
    u1 = XZeiger * cal - YZeiger * sal
    v1 = XZeiger * sal * sbt + YZeiger * cal * sbt + ZZeiger * cbt
    u2 = (XZeiger + LZeiger) * cal - YZeiger * sal
    v2 = (XZeiger + LZeiger) * sal * sbt + YZeiger * cal * sbt + ZZeiger * cbt
    Form4.Line (xmin + u1 * zoom3D, ymin - v1 * zoom3D)-(xmin + u2 * zoom3D, ymin - v2 * zoom3D), Hrot
Rem Zeiger Y
    u2 = XZeiger * cal - (YZeiger + LZeiger) * sal
    v2 = XZeiger * sal * sbt + (YZeiger + LZeiger) * cal * sbt + ZZeiger * cbt
    Form4.Line (xmin + u1 * zoom3D, ymin - v1 * zoom3D)-(xmin + u2 * zoom3D, ymin - v2 * zoom3D), Hrot
Rem Zeiger Z
    u2 = XZeiger * cal - YZeiger * sal
    v2 = XZeiger * sal * sbt + YZeiger * cal * sbt + (ZZeiger + LZeiger) * cbt
    Form4.Line (xmin + u1 * zoom3D, ymin - v1 * zoom3D)-(xmin + u2 * zoom3D, ymin - v2 * zoom3D), Hrot

Else
    vvy = -ynul
For i = 1 To n
    Call tranp(X1(i), Y1(i), Z1(i), u1, v1)
    Call tranp(X2(i), Y2(i), Z2(i), u2, v2)
    If (v1 > ynul + 500) And (v2 > ynul + 500) Then
    uz1 = vvy * u1 / (v1 - ynul) * zoom3D
    uz2 = vvy * u2 / (v2 - ynul) * zoom3D
    vz1 = vvy * (Z1(i) - znul) / (v1 - ynul) * zoom3D
    vz2 = vvy * (Z2(i) - znul) / (v2 - ynul) * zoom3D
    Form4.Line (xmin + uz1, ymin - vz1)-(xmin + uz2, ymin - vz2), Fa(i)
    End If
Next i
Rem Zeiger X
    Call tranp(XZeiger, YZeiger, ZZeiger, u1, v1)
    Call tranp(XZeiger + LZeiger, YZeiger, ZZeiger, u2, v2)
    If (v1 > ynul + 500) And (v2 > ynul + 500) Then
    uz1 = vvy * u1 / (v1 - ynul) * zoom3D
    uz2 = vvy * u2 / (v2 - ynul) * zoom3D
    vz1 = vvy * (ZZeiger - znul) / (v1 - ynul) * zoom3D
    vz2 = vvy * (ZZeiger - znul) / (v2 - ynul) * zoom3D
    Form4.Line (xmin + uz1, ymin - vz1)-(xmin + uz2, ymin - vz2), Hrot
    End If
Rem Zeiger Y
    Call tranp(XZeiger, YZeiger + LZeiger, ZZeiger, u2, v2)
    If (v1 > ynul + 500) And (v2 > ynul + 500) Then
    uz1 = vvy * u1 / (v1 - ynul) * zoom3D
    uz2 = vvy * u2 / (v2 - ynul) * zoom3D
    vz1 = vvy * (ZZeiger - znul) / (v1 - ynul) * zoom3D
    vz2 = vvy * (ZZeiger - znul) / (v2 - ynul) * zoom3D
    Form4.Line (xmin + uz1, ymin - vz1)-(xmin + uz2, ymin - vz2), Hrot
    End If
Rem Zeiger Z
    Call tranp(XZeiger, YZeiger, ZZeiger + LZeiger, u2, v2)
    'If (v1 > ynul + 500) And (v2 > ynul + 500) Then
    uz1 = vvy * u1 / (v1 - ynul) * zoom3D
    uz2 = vvy * u2 / (v2 - ynul) * zoom3D
    vz1 = vvy * (ZZeiger - znul) / (v1 - ynul) * zoom3D
    vz2 = vvy * (ZZeiger + LZeiger - znul) / (v2 - ynul) * zoom3D
    Form4.Line (xmin + uz1, ymin - vz1)-(xmin + uz2, ymin - vz2), Hrot
    'End If
End If
 '
'screen.MousePointer = 0

End Sub



Public Sub Popup()
Select Case MDIForm1.ActiveForm.WindowState
Case 0:
MDIForm1.Normal.Enabled = False
Case 1:
MDIForm1.Icon.Enabled = False
Case 2:
MDIForm1.Voll.Enabled = False
End Select
MDIForm1.ActiveForm.PopupMenu MDIForm1.Popup
End Sub
